
#-----------------------------------------------------------------------------
#  model0  (ver. 0.1) -- Estimating Agglomeration Model 0
#  Copyright (C) 2007 Giulio Bottazzi and Angelo Secchi

#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  (version 2) as published by the Free Software Foundation;
  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
  
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#------------------------------------------------------------------------------



#MODEL 0 fitting
#------------------

import string
from math import *
from scipy import special
from scipy.stats import histogram2
from scipy.stats import binom
from numpy import *
import shelve
import Scientific.IO.ArrayIO


storage=shelve.open("shelve_regression")
matricione=storage["matricione"]
storage.close()

nsec=len(matricione[1])

emp={}
t0={}

for sec in range(nsec):
    storage=shelve.open("shelve_regression")
    matricione=storage["matricione"]
    storage.close()
    empdata=matricione[:,sec]
    L=len(matricione)
    N=sum(empdata)
    nmax= int(max(empdata))
    maxindex=int(ceil(log(nmax+2)/log(2)-1))
    empfreq=histogram2(empdata,[ 2**k-1  for k in range(maxindex) ])/float(L)
    empfreq=hstack((empfreq,array(0.0)))
    freq=binom.pmf(range(nmax),N,1.0/L)
    classfreq = [ sum(freq[2**k-1:2**(k+1)-1]) for k in range(maxindex) ]
    classfreq.append(1.-sum(classfreq))
    teor0=array(classfreq)
    emp[sec]=empfreq[:-1]*L
    t0[sec]=teor0*L



storage=shelve.open("shelve_results")


storage['emp']=emp
storage['t0']=t0

storage.close()


#Creating Shelve
#----------------------------

storage=shelve.open("shelve_results")

emp=storage['emp']
t0=storage['t0']

storage.close()


Emp=[]
T0=[]

for sec in range(nsec):
    empirica=emp[sec]
    teorica0=t0[sec]
    Emp.append(empirica)
    T0.append(teorica0)

#Creating Files
#----------------------------


output=file("results/model0_emp.txt","w")

for sec in Emp:
    print >> output, str(sec)[1:-1]

output.close()

output=file("results/model0_theo.txt","w")

for sec in T0:
    print >> output, str(sec).replace('\n','')[1:-1]

output.close()




